package com.inspur.fabric.config;

import com.inspur.fabric.core.factory.DefaultFabricEntityFactory;
import com.inspur.fabric.core.util.BlockUtil;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;

/**
 * @author zhanglan
 * @description
 * @date 2021/8/13
 */
@EnableConfigurationProperties(BaasProperties.class)
public class BaasConfiguration {

    @Bean
    public PropertiesConfigService propertiesConfigService(BaasProperties baasProperties) {
        return new PropertiesConfigService(baasProperties);
    }

    @Bean
    public DefaultFabricEntityFactory defaultFabricEntityFactory(PropertiesConfigService propertiesConfigService) {
        return DefaultFabricEntityFactory.getInstance(propertiesConfigService);
    }

    @Bean
    public BlockUtil blockUtil() {
        return BlockUtil.getInstance();
    }

}
