package com.inspur.fabric.core.chaincode;

import com.alibaba.fastjson.JSONObject;
import com.inspur.fabric.core.entity.ChannelEntity;
import org.hyperledger.fabric.sdk.ChaincodeID;

import java.util.Map;

/**
 * @author zhanglan
 * @description
 * @date 2021/8/13
 */
public class DataChaincode extends AbstractChaincode {

    private String ccName;
    private String ccVersion;


    public DataChaincode(ChannelEntity channel, String ccName, String ccVersion) {
        this.ccName = ccName;
        this.ccVersion = ccVersion;
        init(channel);
    }

    @Override
    protected void init(ChannelEntity channel) {
        this.channel = channel;
        this.chaincodeID = ChaincodeID.newBuilder().setName(this.ccName).setVersion(this.ccVersion).build();
    }

    public String invokeCc(String funcName, String[] ccArgs) {
        Map<String, Object> map = invoke(funcName, ccArgs);
        return JSONObject.toJSONString(map);
    }

    public String queryCc(String funcName, String[] ccArgs) {
        return query(funcName, ccArgs);
    }

}
