package com.inspur.fabric.core.entity;

import org.hyperledger.fabric.sdk.User;

/**
 * @author zhanglan
 * @description
 * @date 2021/8/13
 */
public abstract class AbstractIdentityEntity implements User {

    /**
     * 身份所属租户或用户的id
     *
     * @return
     */
    public abstract String getUserId();


    /**
     * 获取用户所属组织的orgName
     *
     * @return
     */
    abstract String getOrgName();

    public abstract String getIdentityId();

    /**
     * 返回身份类型
     *
     * @return
     */
    public abstract String getIdentityType();

    @Override
    public String getName() {
        return getIdentityId();
    }

}
