package com.inspur.fabric.core.entity;

import lombok.Data;
import org.hyperledger.fabric.sdk.Enrollment;

import java.util.Set;

/**
 * @author zhanglan
 * @description
 * @date 2021/8/13
 */
@Data
public class CommonIdentityEntity extends AbstractIdentityEntity {
    private final String orgName;

    private final String userId;

    private final String identityId;

    private final Enrollment enrollment;

    private final String mspId;

    private String walletSecret;

    private Set<String> roles;

    private String account;

    private String affiliation;

    private CommonIdentityEntity(String userId, String identityId, String orgName, String mspId, String walletSecret, Enrollment enrollment) {
        this.userId = userId;
        this.identityId = identityId;
        this.orgName = orgName;
        this.mspId = mspId;
        this.walletSecret = walletSecret;
        this.enrollment = enrollment;
    }


    @Override
    public String getIdentityType() {
        return "00";
    }

    public static class Builder {
        private String orgName;

        private String userId;

        private String identityId;

        private Enrollment enrollment;

        private String mspId;

        private String walletSecret;

        private Builder() {
        }

        public Builder setOrgName(String orgName) {
            this.orgName = orgName;
            return this;
        }

        public Builder setUserId(String userId) {
            this.userId = userId;
            return this;
        }

        public Builder setIdentityId(String identityId) {
            this.identityId = identityId;
            return this;
        }

        public Builder setEnrollment(Enrollment enrollment) {
            this.enrollment = enrollment;
            return this;
        }

        public Builder setMspId(String mspId) {
            this.mspId = mspId;
            return this;
        }

        public Builder setWalletSecret(String walletSecret) {
            this.walletSecret = walletSecret;
            return this;
        }

        public CommonIdentityEntity build() {
            CommonIdentityEntity user = new CommonIdentityEntity(userId, identityId, orgName, mspId, walletSecret, enrollment);
            return user;
        }

    }

    public static Builder newBuilder() {
        return new Builder();
    }

}
