package com.inspur.fabric.core.entity;

import lombok.Data;
import org.hyperledger.fabric.sdk.User;
import org.hyperledger.fabric.sdk.exception.CryptoException;
import org.hyperledger.fabric.sdk.exception.InvalidArgumentException;
import org.hyperledger.fabric.sdk.security.CryptoSuite;
import org.hyperledger.fabric_ca.sdk.HFCAClient;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.Collection;

/**
 * @author zhanglan
 * @description
 * @date 2021/8/13
 */
@Data
public class OrgEntity {

    private String orgName;

    private String domainName;

    private String mspId;

    private HFCAClient caClient;

    private User admin;

    private User peerAdmin;

    private Collection<PeerEntity> peers = new ArrayList<PeerEntity>();

    public OrgEntity(String orgName) {
        setOrgName(orgName);
    }

    public void addPeer(PeerEntity peer) {
        peers.add(peer);
    }

    public void setCaClient(HFCAClient caClient) throws IllegalAccessException, InvocationTargetException, InvalidArgumentException, InstantiationException, NoSuchMethodException, CryptoException, ClassNotFoundException {
        this.caClient = caClient;
        caClient.setCryptoSuite(CryptoSuite.Factory.getCryptoSuite());
    }

    public String toString() {
        return String.format("{orgName: %s, mspId: %s}", orgName, mspId);
    }
}
